//+------------------------------------------------------------------+
//|                                     One more average heiken ashi |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  clrLimeGreen
#property indicator_color2  clrOrange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame          = PERIOD_CURRENT;
extern int             OmaPeriod          = 20;
extern double          OmaSpeed           = 3.0;
extern bool            OmaAdaptive        = true;
extern bool            BetterFormula      = true;
extern double          Step               = 0;
extern bool            alertsOn           = false;
extern bool            alertsOnCurrent    = true;
extern bool            alertsMessage      = true;
extern bool            alertsNotification = false;
extern bool            alertsSound        = false;
extern bool            alertsEmail        = false;

//
//
//
//
//

double ExtMapBuffer0[];
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double trend[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0, ExtMapBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, ExtMapBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, ExtMapBuffer0);
   SetIndexBuffer(3, ExtMapBuffer3);
   SetIndexBuffer(4, ExtMapBuffer4);
   SetIndexBuffer(5, trend);
   
      //
      //
      //
      //
      //
      
         OmaPeriod         = MathMax(OmaPeriod,1);
         OmaSpeed          = MathMax(OmaSpeed,-1.5);
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame==-99);
         TimeFrame         = MathMax(TimeFrame,_Period);
      
      //
      //
      //
      //
      //
      
   IndicatorShortName(timeFrameToString(TimeFrame)+" One more average Heiken Ashi Lines("+OmaPeriod+","+DoubleToStr(OmaSpeed,2)+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ExtMapBuffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
         if (Digits==3 || Digits==5)
               double pointModifier = 10;
         else         pointModifier = 1;               
         for(int i = limit; i >= 0; i--)
         {
            double maOpen  = iAverage(Open[i], OmaPeriod,OmaSpeed,OmaAdaptive,i,0);
            double maClose = iAverage(Close[i],OmaPeriod,OmaSpeed,OmaAdaptive,i,1);
            double maLow   = iAverage(Low[i],  OmaPeriod,OmaSpeed,OmaAdaptive,i,2);
            double maHigh  = iAverage(High[i], OmaPeriod,OmaSpeed,OmaAdaptive,i,3);
   
            //
            //
            //
            //
            //
        
            if (BetterFormula) {
                  if (maHigh!=maLow)
                        double haClose = (maOpen+maClose)/2+(((maClose-maOpen)/(maHigh-maLow))*MathAbs((maClose-maOpen)/2));
                  else         haClose = (maOpen+maClose)/2; }
            else               haClose = (maOpen+maHigh+maLow+maClose)/4;
                        double haOpen   = (ExtMapBuffer3[i+1]+ExtMapBuffer4[i+1])/2;
 
                               ExtMapBuffer3[i]=haOpen;
                               ExtMapBuffer4[i]=haClose;
   
            //
            //
            //
            //
            //
        
            if (Step>0)
            {
               if( MathAbs(ExtMapBuffer3[i]-ExtMapBuffer3[i+1]) < Step*pointModifier*Point ) ExtMapBuffer3[i]=ExtMapBuffer3[i+1];
               if( MathAbs(ExtMapBuffer4[i]-ExtMapBuffer4[i+1]) < Step*pointModifier*Point ) ExtMapBuffer4[i]=ExtMapBuffer4[i+1];
            }   
            ExtMapBuffer0[i] = (haOpen + haClose)/2;
            ExtMapBuffer1[i] = EMPTY_VALUE;
            ExtMapBuffer2[i] = EMPTY_VALUE;         
            trend[i] = trend[i+1];
               if (ExtMapBuffer3[i]<ExtMapBuffer4[i]) trend[i] =  1;
               if (ExtMapBuffer3[i]>ExtMapBuffer4[i]) trend[i] = -1;
               if (trend[i] == 1) ExtMapBuffer1[i] = 1;
               if (trend[i] ==-1) ExtMapBuffer2[i] = 1;
         }  
   
         //
         //
         //
         //
         //
   
         if (alertsOn)
         {
            if (alertsOnCurrent)
                 int whichBar = 0;
            else     whichBar = 1;
            if (trend[whichBar] != trend[whichBar+1])
            if (trend[whichBar] == 1)
                  doAlert("up");
            else  doAlert("down");       
         }
      return(0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         ExtMapBuffer1[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,OmaPeriod,OmaSpeed,OmaAdaptive,BetterFormula,Step,alertsOn,alertsOnCurrent,alertsMessage,alertsNotification,alertsSound,alertsEmail,0,y);
         ExtMapBuffer2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,OmaPeriod,OmaSpeed,OmaAdaptive,BetterFormula,Step,alertsOn,alertsOnCurrent,alertsMessage,alertsNotification,alertsSound,alertsEmail,1,y);
   }          
return(0);            
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define omaInstances 4
double workOma[][omaInstances*7];
#define E1  0
#define E2  1
#define E3  2
#define E4  3
#define E5  4
#define E6  5
#define res 6

//
//
//
//
//

double iAverage(double price, double averagePeriod, double tconst, bool adaptive, int i, int instanceNo=0)
{
   if (averagePeriod <=1) return(price); int r = Bars-i-1; instanceNo *= 7;
   if (ArrayRange(workOma,0)!=Bars) ArrayResize(workOma,Bars);
   
   double e1=workOma[(int)MathMax(r-1,0)][instanceNo+E1];  double e2=workOma[(int)MathMax(r-1,0)][instanceNo+E2];
   double e3=workOma[(int)MathMax(r-1,0)][instanceNo+E3];  double e4=workOma[(int)MathMax(r-1,0)][instanceNo+E4];
   double e5=workOma[(int)MathMax(r-1,0)][instanceNo+E5];  double e6=workOma[(int)MathMax(r-1,0)][instanceNo+E6];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = averagePeriod/2.0;
         double maxPeriod = minPeriod*5.0;
         int    endPeriod = (int)MathCeil(maxPeriod);
         double signal    = MathAbs((price-workOma[(int)MathMax(r-endPeriod,0)][instanceNo+res]));
         double noise     = 0.00000000001;

            for(int k=1; k<endPeriod && r-k>=0; k++) noise=noise+MathAbs(price-workOma[r-k][instanceNo+res]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double alpha = (2.0+tconst)/(1.0+tconst+averagePeriod);

      e1 = e1 + alpha*(price-e1); e2 = e2 + alpha*(e1-e2); double v1 = 1.5 * e1 - 0.5 * e2;
      e3 = e3 + alpha*(v1   -e3); e4 = e4 + alpha*(e3-e4); double v2 = 1.5 * e3 - 0.5 * e4;
      e5 = e5 + alpha*(v2   -e5); e6 = e6 + alpha*(e5-e6); double v3 = 1.5 * e5 - 0.5 * e6;

   //
   //
   //
   //
   //

   workOma[r][instanceNo+E1]  = e1;  workOma[r][instanceNo+E2] = e2;
   workOma[r][instanceNo+E3]  = e3;  workOma[r][instanceNo+E4] = e4;
   workOma[r][instanceNo+E5]  = e5;  workOma[r][instanceNo+E6] = e6;
   workOma[r][instanceNo+res] = price;
   return(v3);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," OMA HA changed trend to ",doWhat);
             if (alertsMessage)      Alert(message);
             if (alertsNotification) SendNotification(message);
             if (alertsEmail)        SendMail(StringConcatenate(Symbol()," OMA HA"),message);
             if (alertsSound)        PlaySound("alert2.wav");
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}